Skip to main content

RGWError

radosgw-admin


Class: RGWError

Defined in: src/errors.ts:21

Base error class for all RGW Admin API errors.

Every error includes:

  • statusCode — HTTP status (undefined for client-side validation errors)
  • code — RGW error code from the response body (e.g. NoSuchUser, BucketAlreadyExists)

Example​

try {
await rgw.users.get('alice');
} catch (err) {
if (err instanceof RGWError) {
console.log(err.statusCode); // 404
console.log(err.code); // "NoSuchUser"
console.log(err.message); // "No user found with the given UID"
}
}

Extends​

  • Error

Extended by​

Constructors​

Constructor​

new RGWError(message, statusCode?, code?, uid?): RGWError

Defined in: src/errors.ts:22

Parameters​

message​

string

statusCode?​

number

code?​

string

uid?​

string

Returns​

RGWError

Overrides​

Error.constructor

Properties​

cause?​

optional cause?: unknown

Defined in: node_modules/typescript/lib/lib.es2022.error.d.ts:26

Inherited from​

Error.cause


code?​

readonly optional code?: string

Defined in: src/errors.ts:25


message​

message: string

Defined in: node_modules/typescript/lib/lib.es5.d.ts:1077

Inherited from​

Error.message


name​

name: string

Defined in: node_modules/typescript/lib/lib.es5.d.ts:1076

Inherited from​

Error.name


stack?​

optional stack?: string

Defined in: node_modules/typescript/lib/lib.es5.d.ts:1078

Inherited from​

Error.stack


statusCode?​

readonly optional statusCode?: number

Defined in: src/errors.ts:24


uid?​

readonly optional uid?: string

Defined in: src/errors.ts:26


stackTraceLimit​

static stackTraceLimit: number

Defined in: node_modules/@types/node/globals.d.ts:67

The Error.stackTraceLimit property specifies the number of stack frames collected by a stack trace (whether generated by new Error().stack or Error.captureStackTrace(obj)).

The default value is 10 but may be set to any valid JavaScript number. Changes will affect any stack trace captured after the value has been changed.

If set to a non-number value, or set to a negative number, stack traces will not capture any frames.

Inherited from​

Error.stackTraceLimit

Methods​

captureStackTrace()​

static captureStackTrace(targetObject, constructorOpt?): void

Defined in: node_modules/@types/node/globals.d.ts:51

Creates a .stack property on targetObject, which when accessed returns a string representing the location in the code at which Error.captureStackTrace() was called.

const myObject = {};
Error.captureStackTrace(myObject);
myObject.stack; // Similar to `new Error().stack`

The first line of the trace will be prefixed with ${myObject.name}: ${myObject.message}.

The optional constructorOpt argument accepts a function. If given, all frames above constructorOpt, including constructorOpt, will be omitted from the generated stack trace.

The constructorOpt argument is useful for hiding implementation details of error generation from the user. For instance:

function a() {
b();
}

function b() {
c();
}

function c() {
// Create an error without stack trace to avoid calculating the stack trace twice.
const { stackTraceLimit } = Error;
Error.stackTraceLimit = 0;
const error = new Error();
Error.stackTraceLimit = stackTraceLimit;

// Capture the stack trace above function b
Error.captureStackTrace(error, b); // Neither function c, nor b is included in the stack trace
throw error;
}

a();

Parameters​

targetObject​

object

constructorOpt?​

Function

Returns​

void

Inherited from​

Error.captureStackTrace


prepareStackTrace()​

static prepareStackTrace(err, stackTraces): any

Defined in: node_modules/@types/node/globals.d.ts:55

Parameters​

err​

Error

stackTraces​

CallSite[]

Returns​

any

See​

https://v8.dev/docs/stack-trace-api#customizing-stack-traces

Inherited from​

Error.prepareStackTrace